CON

  _clkmode        = xtal1 + pll16x                      ' Feedback and PLL multiplier
  _xinfreq        = 5_000_000                           ' External oscillator = 5 MHz

  MS_001   = 80_000_000 / 1_000
  
obj

  term     : "fullduplexserialdp_1"
  encdr    : "grayenc2_with_pb"                           ' 2-bit, graycode encoder
  
var                                                     
 
PUB Main | idx, idxadd, idxatt, idxv, i, i1, i2, i3, i4, i5                                       

  encdr.init(20, 1, 1, 512, 1, 22)                      ' detented encoder on P20 and pushbutton on P22 
                                                        ' (base, hasdetent, lo, hi, preset, pbpin)
                                                        ' Start encoder with range of 1 to 512 preset to 1  
  term.start(31, 30, %0000, 115_200)                    ' start terminal using FDS
  pause(1000)

  term.str(string("Encoder test", 13, 13))
  
  encdr.chgrange(1, 3, 1)                               ' (lo, hi, preset)
                                                        ' Change range of encoder to 1 to 6 preset to 1

  term.str(string(13, "Encoder: "))
  term.dec(encdr.read)
  term.str(string(" Lo: "))
  term.dec(encdr.readlo)
  term.str(string(" Hi: "))
  term.dec(encdr.readhi)
  term.tx(13)

  i  := 1
  i1 := 2
  i2 := 3
  i3 := 4
  i4 := 5
  i5 := 6

  idxadd := 1
  idxatt := 1
  idxv := 0

   repeat

      idx := encdr.read
   
      case idx 
      
        1 :

          if i == idx
            repeat 1                                            
              term.str(string("Case 1", 13))
              term.str(string("Encoder: "))
              term.dec(encdr.read)
              term.str(string(" Lo: "))
              term.dec(encdr.readlo)
              term.str(string(" Hi: "))
              term.dec(encdr.readhi)
              term.tx(13)
              i := 9
              i1 := 2
          
          if encdr.ispushed == 1
            release
            encdr.chgrange(1, 512, 1)                   ' Change encoder to full range of 512 preset to 1
            
            repeat
              idx := (encdr.read // 513)
              if idx <> idxadd 
                term.str(string("Encoder: "))
                term.dec(encdr.read)
                term.str(string(" Lo: "))
                term.dec(encdr.readlo)
                term.str(string(" Hi: "))
                term.dec(encdr.readhi)
                term.tx(13)
                idxadd := idx
              if encdr.ispushed == 1
                release
                encdr.chgrange(1, 3, 1)
                term.str(string("Encoder: "))
                term.dec(encdr.read)
                term.str(string(" Lo: "))
                term.dec(encdr.readlo)
                term.str(string(" Hi: "))
                term.dec(encdr.readhi)
                term.tx(13)
                quit
                  
        2:                                              
          if i1 == idx
            repeat 1                                            
              term.str(string("Case 2", 13))
              term.str(string("Encoder: "))
              term.dec(encdr.read)
              term.str(string(" Lo: "))
              term.dec(encdr.readlo)
              term.str(string(" Hi: "))
              term.dec(encdr.readhi)
              term.tx(13)
              i := 1
              i1 := 0
              i2 :=3
          
          if encdr.ispushed == 1
            release
            encdr.chgrange(1, 100, 1)                   
            
            repeat
              idx := (encdr.read // 101)
              if idx <> idxatt
                term.str(string("Encoder: "))
                term.dec(encdr.read)
                term.str(string(" Lo: "))
                term.dec(encdr.readlo)
                term.str(string(" Hi: "))
                term.dec(encdr.readhi)
                term.tx(13)
                idxatt := idx
              if encdr.ispushed == 1
                release
                encdr.chgrange(1, 3, 1)
                term.str(string("Encoder: "))
                term.dec(encdr.read)
                term.str(string(" Lo: "))
                term.dec(encdr.readlo)
                term.str(string(" Hi: "))
                term.dec(encdr.readhi)
                term.tx(13)
                quit

        3:                                              
          if i2 == idx
            repeat 1                                            
              term.str(string("Case 3", 13))
              term.str(string("Encoder: "))
              term.dec(encdr.read)
              term.str(string(" Lo: "))
              term.dec(encdr.readlo)
              term.str(string(" Hi: "))
              term.dec(encdr.readhi)
              term.tx(13)
              i := 1
              i1 := 2
              i2 := 0
          
          if encdr.ispushed == 1
            release
            encdr.chgrange(1, 10, 1)                   
            
            repeat
              idx := (encdr.read // 11)
              if idx <> idxv
                term.str(string("Encoder: "))
                term.dec(encdr.read)
                term.str(string(" Lo: "))
                term.dec(encdr.readlo)
                term.str(string(" Hi: "))
                term.dec(encdr.readhi)
                term.tx(13)
                idxv := idx
              if encdr.ispushed == 1
                release
                encdr.chgrange(1, 2, 1)
                term.str(string("Encoder: "))
                term.dec(encdr.read)
                term.str(string(" Lo: "))
                term.dec(encdr.readlo)
                term.str(string(" Hi: "))
                term.dec(encdr.readhi)
                term.tx(13)
                quit                

pub  release   'wait for button release

  repeat until encdr.ispushed == 0
            
pub pause(ms) | t

  t := cnt
  repeat ms
    waitcnt(t += MS_001)
